# Korn shell commands to define IDL environment variables and aliases.
#
# This script can be used by IDL users who use ksh as their interactive shell
# to define the environment variables and aliases required by IDL
# related commands (idl, idlde, idlhelp, idldemo) if the symbolic links to
# the default directory (/usr/local/rsi/idl) are not being used.
#
# ksh users should run idl_setup from their .profile file 
# using the following command:
#
#    . /d2/hotmix/new_hot/i/idl_5/bin/idl_setup.ksh
#
IDL_DIR=/d2/hotmix/new_hot/i/idl_5
export IDL_DIR
IDL_PATH=\+$IDL_DIR/lib:\+$IDL_DIR/examples
export IDL_PATH
alias -x idl=$IDL_DIR/bin/idl
alias -x idlde=$IDL_DIR/bin/idlde
alias -x idlhelp=$IDL_DIR/bin/idlhelp
alias -x idlrpc=$IDL_DIR/bin/idlrpc
alias -x insight=$IDL_DIR/bin/insight
alias -x idldemo=$IDL_DIR/bin/idldemo
