;------------------------------------------------
;
;    PURPOSE  Size the tip widget to be half of
;             the top level base width and map
;             the base that contains the tip widgets.
;
pro sizeTips, $
    wTopBase, $    ; IN: top level base
    wText, $       ; IN: ID of the 2 tip text widgets
    wTipBase       ; IN: base of the 2 tip widgets.

    ;  Get the x size of the top level base.
    ;
    tlbGeometry = WIDGET_INFO(wTopBase, /GEOMETRY)
    tlbXSize = tlbGeometry.xsize + (2 * tlbGeometry.margin)
 
    ;  Size the tip widgets.
    ;
    WIDGET_CONTROL, wText[0], SCR_XSIZE = tlbXSize/2 - 5
    WIDGET_CONTROL, wText[1], SCR_XSIZE = tlbXSize/2 - 5

    ;  Map the tip widgets.
    ;
    WIDGET_CONTROL, wTipBase, MAP=1

end    ;  of sizeTips
