; $Id: live_image.pro,v 1.5 1997/04/16 20:20:58 billo Exp $
;
; Copyright (c) 1996-1997, Research Systems, Inc.  All rights reserved.
;       Unauthorized reproduction prohibited.
;
;+
; NAME:
;       LIVE_IMAGE
;
; PURPOSE:
;       Entry point to LIVE_IMAGE
;
; CALLING SEQUENCE:
;       LIVE_IMAGE, image
;
; OPTIONAL KEYWORDS:
;		RED=red                     ; Vector of red [optional]
;		GREEN=green                 ; Vector of green [optional]
;		BLUE=blue                   ; Vector of blue [optional]
;		STYLE=style                 ; A style name (string) [optional]
;		INDEXED_COLOR=indexedColor  ; Set to use indexed color [optional]
;
; DEVELOPMENT NOTES:
;		-
;
;------------------------------------------------------------------------------
pro Live_Image, image, _EXTRA=extra

	ON_ERROR, 2

	WIDGET_CONTROL, /HOURGLASS

	; Determine if the L_IMAGE routine has been resolved
	;
	result = ROUTINE_INFO(/UNRESOLVED)

	void = WHERE(result eq 'L_IMAGE', count)

	; If the L_IMAGE routine has not been resolved find insight.sav
	; and restore it.
	;
	if (count ne 0) then begin

		; Look for insight in its default location idlxx/lib/hook
		;
		insightPath = FILEPATH('insight.sav', SUBDIR=['lib','hook'])
		void = FINDFILE(insightPath, COUNT=count)

		; If it wasn't found, notify the user.
		;
		if (count eq 0) then begin

			result = DIALOG_MESSAGE($
				['Insight was not found.',$
				'Please make sure insight.sav is in your hook directory', $
				'and !DIR points to your IDL directory.', $
				'Do you wish to locate insight.sav?'], /CANCEL)

			; If they want to search for it, display std file dialog.
			;
			if (result eq 'OK') then begin

				insightPath = $
					DIALOG_PICKFILE(TITLE='PLease locate insight.sav', $
						/MUST_EXIST)

				if (insightPath eq '') then $
					return

			endif else $
				return

		endif

		; Restore L_IMAGE code
		;
		restore, insightPath
	endif

	; Call L_IMAGE with passed in parameters
	;
	L_IMAGE, image, _EXTRA=extra

end
