; $Id: ncdf_exists.pro,v 1.3 1997/02/22 02:33:32 ali Exp $
;
; Copyright (c) 1992-1997, Research Systems, Inc.  All rights reserved.
;	Unauthorized reproduction prohibited.
;
;+
; NAME:
;	NCDF_EXISTS
;
; PURPOSE:
;	Test for the existence of the NetCDF library
;
; CATEGORY:
;	File Formats
;
; CALLING SEQUENCE:
;	Result = NCDF_EXISTS()
;
; INPUTS:
;	None.
;
; KEYWORD PARAMETERS:
;	None.
;
; OUTPUTS:
;	Returns TRUE (1) if the NetCDF data format library is supported
;	Returns FALSE(0) if it is not.
;
; COMMON BLOCKS:
;	NCDFTEST
;
; EXAMPLE:
;	IF ncdf_exists() EQ 0 THEN Fail,"Library not supported on this machine"
;
; MODIFICATION HISTORY
;	Written by:	Joshua Goldstein,  12/8/92
;
;-

PRO	ncdf_control, cid, VERBOSE=v
	common	ncdftest, has_ncdf
	has_ncdf	= 0
end

FUNCTION ncdf_exists
	common	ncdftest, has_ncdf

	; CDF is not available in the IDL Student Edition
	;
	; NOTE: The LMGR function is undocumented, considered private
	; to RSI, and is subject to change or removal from IDL at any
	; time without notice.
	if (LMGR(/STUDENT) eq 1) then return, 0

	has_ncdf	= 1
	ncdf_control,0,/verbose
	return, has_ncdf
END
